#ifndef __G69DDC_EXAMPLE_H__
#define __G69DDC_EXAMPLE_H__

#include "g69ddcapi.h"
#include <pulse/simple.h>

class TG69DDC:public IG69DDCDeviceCallback
{
public:
    bool LoadAPI(void);
    void UnloadAPI(void);

    bool Open(const char *DevicePath);

    inline bool OpenFirst(void)
    {
        //open the first available G69DDC receiver
        return Open(G69DDC_OPEN_FIRST);
    }

    inline bool OpenDemo(void)
    {
        //open demo G69DDC receiver
        return Open(G69DDC_OPEN_DEMO);
    }

    void Close(void);

    void StartStreaming(void);
    void StopStreaming(void);


    void OpenWaveOut(void);
    void CloseWaveOut(void);

    //methods of IG69DDCDeviceCallback callback interface
    void G69DDC_DDC1StreamCallback(IG69DDCDevice *Device,uint32_t DDC1ChannelId,const void *Buffer,uint32_t Count,uint32_t BitsPerSample);
    int G69DDC_DDC1PlaybackStreamCallback(IG69DDCDevice *Device,uint32_t DDC1ChannelId,void *Buffer,uint32_t Count,uint32_t BitsPerSample);
    void G69DDC_DDC2StreamCallback(IG69DDCDevice *Device,uint32_t DDC2ChannelId,const float *Buffer,uint32_t Count);
    void G69DDC_DDC2PreprocessedStreamCallback(IG69DDCDevice *Device,uint32_t DDC2ChannelId,const float *Buffer,uint32_t Count,float SlevelPeak,float SlevelRMS);
    void G69DDC_ADCSnapshotCallback(IG69DDCDevice *Device,const int16_t *Buffer,uint32_t Count,uint32_t CenterFrequency,uint16_t ADCLevel);
    void G69DDC_AudioStreamCallback(IG69DDCDevice *Device,uint32_t DDC2ChannelId,uint32_t Stage,const float *Buffer,uint32_t Count);
    int G69DDC_AudioPlaybackStreamCallback(IG69DDCDevice *Device,uint32_t DDC2ChannelId,float *Buffer,uint32_t Count);
    int G69DDC_SweeperCallback(IG69DDCDevice *Device,const short *Buffer,uint32_t Count,uint32_t CenterFrequency,uint64_t FrontEndFrequency,uint32_t Repeat);

    TG69DDC(void);
    ~TG69DDC(void);
private:
    IG69DDCDevice               *m_Device;
    void                        *m_API;
    G69DDC_CREATE_INSTANCE      m_CreateInstance;
    pa_simple                   *m_PaSimple;
    uint32_t                    m_DDC1Id;
    uint32_t                    m_DDC2Id;
};

#endif
